Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/CategoryDaoImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/CategoryDaoImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/CategoryDaoImpl.java	(revision 9919)
@@ -0,0 +1,120 @@
+package fr.mael.jiwigo.dao.impl;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+
+import fr.mael.jiwigo.dao.CategoryDao;
+import fr.mael.jiwigo.om.Category;
+import fr.mael.jiwigo.transverse.enumeration.CategoryEnum;
+import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
+import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+import fr.mael.jiwigo.transverse.session.SessionManager;
+import fr.mael.jiwigo.transverse.util.Tools;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+ * Dao for the categories
+ * @author mael
+ *
+ */
+public class CategoryDaoImpl implements CategoryDao {
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(CategoryDaoImpl.class);
+    /**
+     * Instance to use a singleton
+     */
+    private static CategoryDaoImpl instance;
+
+    private SessionManager sessionManager;
+
+    /**
+     * Lists the categories
+     * @param recursive true : recursive listing of the categories
+     * @return the list of categories
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Category> list(boolean recursive) throws IOException, ProxyAuthenticationException {
+	Document doc = sessionManager.executeReturnDocument(MethodsEnum.LISTER_CATEGORIES.getLabel(), "recursive",
+		String.valueOf(recursive));
+	Element element = (Element) doc.getDocumentElement().getElementsByTagName("categories").item(0);
+	NodeList nodeList = element.getElementsByTagName("category");
+	ArrayList<Category> categories = new ArrayList<Category>();
+	for (int i = 0; i < nodeList.getLength(); i++) {
+	    Node catNode = nodeList.item(i);
+	    if (catNode.getNodeType() == Node.ELEMENT_NODE) {
+		Element cat = (Element) catNode;
+		Category myCat = new Category();
+		myCat.setIdentifier(Integer.valueOf(cat.getAttribute(CategoryEnum.ID.getLabel())));
+		myCat.setUrlCategory(cat.getAttribute(CategoryEnum.URL.getLabel()));
+		myCat.setNbImages(Integer.valueOf(cat.getAttribute(CategoryEnum.NB_IMAGES.getLabel())));
+		myCat.setNbTotalImages(Integer.valueOf(cat.getAttribute(CategoryEnum.NB_TOTAL_IMAGES.getLabel())));
+		myCat.setName(Tools.getStringValueDom(cat, CategoryEnum.NAME.getLabel()));
+		String catMeres = Tools.getStringValueDom(cat, CategoryEnum.CAT_MERES.getLabel());
+		ArrayList<Integer> idCategoriesMeres = new ArrayList<Integer>();
+		myCat.setIdParentCategoriesString(catMeres);
+		for (String catA : catMeres.split(",")) {
+		    if (!catA.equals("")) {
+			idCategoriesMeres.add(Integer.valueOf(catA));
+		    }
+		}
+		myCat.setIdParentCategories(idCategoriesMeres);
+		categories.add(myCat);
+	    }
+	}
+	return categories;
+    }
+
+    /**
+     * Creation of a category
+     * @param category the category to create
+     * @return true if the category is successfully created
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(Category category) throws ProxyAuthenticationException {
+	try {
+	    if (category.getDirectParent() != null) {
+		return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.AJOUTER_CATEGORIE.getLabel(),
+			"name", category.getName(), "parent", String.valueOf(category.getDirectParent())));
+	    } else {
+		return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.AJOUTER_CATEGORIE.getLabel(),
+			"name", category.getName()));
+	    }
+	} catch (IOException e) {
+	    LOG.error(Tools.getStackTrace(e));
+	} catch (FileAlreadyExistsException e) {
+	    LOG.error(Tools.getStackTrace(e));
+	}
+	return false;
+    }
+
+    public SessionManager getSessionManager() {
+	return sessionManager;
+    }
+
+    public void setSessionManager(SessionManager sessionManager) {
+	this.sessionManager = sessionManager;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/CommentDaoImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/CommentDaoImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/CommentDaoImpl.java	(revision 9919)
@@ -0,0 +1,125 @@
+package fr.mael.jiwigo.dao.impl;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+
+import fr.mael.jiwigo.dao.CommentDao;
+import fr.mael.jiwigo.om.Comment;
+import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
+import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+import fr.mael.jiwigo.transverse.session.SessionManager;
+import fr.mael.jiwigo.transverse.util.Tools;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+
+ * Dao for the comments
+ * @author mael
+ *
+ */
+public class CommentDaoImpl implements CommentDao {
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(CommentDaoImpl.class);
+
+    private SessionManager sessionManager;
+
+    /**
+     * Listing of the comments for the given image
+     * @param idImage id of the  image
+     * @return list of comments
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Comment> list(Integer idImage) throws IOException, ProxyAuthenticationException {
+	Document doc = (sessionManager.executeReturnDocument(MethodsEnum.GET_INFO.getLabel(), "image_id", String
+		.valueOf(idImage), "comments_per_page", "100"));
+	Element elementImage = (Element) doc.getDocumentElement().getElementsByTagName("image").item(0);
+	Element elementComments = (Element) elementImage.getElementsByTagName("comments").item(0);
+	NodeList listComments = elementComments.getElementsByTagName("comment");
+	ArrayList<Comment> comments = new ArrayList<Comment>();
+	for (int i = 0; i < listComments.getLength(); i++) {
+	    Node nodeCom = listComments.item(i);
+	    if (nodeCom.getNodeType() == Node.ELEMENT_NODE) {
+		Element com = (Element) nodeCom;
+		Comment myCom = new Comment();
+		myCom.setIdentifier(Integer.valueOf(com.getAttribute("id")));
+		myCom.setDate(com.getAttribute("date"));
+		myCom.setAuthor(Tools.getStringValueDom(com, "author"));
+		myCom.setContent(Tools.getStringValueDom(com, "content"));
+		comments.add(myCom);
+	    }
+	}
+	return comments;
+    }
+
+    /**
+     * Gets the key essential to add a comment
+     * @param idImage the id of the image
+     * @return the key
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public String getKey(Integer idImage) throws IOException, ProxyAuthenticationException {
+	Document doc = (sessionManager.executeReturnDocument(MethodsEnum.GET_INFO.getLabel(), "image_id", String
+		.valueOf(idImage)));
+	//	String key = doc.getRootElement().getChild("image").getChild("comment_post").getAttributeValue("key");
+	Element elementImage = (Element) doc.getDocumentElement().getElementsByTagName("image").item(0);
+	Element elementCommentPost = (Element) elementImage.getElementsByTagName("comment_post").item(0);
+	return elementCommentPost.getAttribute("key");
+    }
+
+    /**
+     * Creates a comment
+     * @param commentaire the comment to add
+     * @return true if the comment is successfully added
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(Comment commentaire) throws IOException, ProxyAuthenticationException {
+	String key = getKey(commentaire.getImageId());
+	try {
+	    Thread.sleep(2200);
+	} catch (InterruptedException e) {
+	    e.printStackTrace();
+	}
+	try {
+	    return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.AJOUTER_COMMENTAIRE.getLabel(),
+		    "image_id", String.valueOf(commentaire.getImageId()), "author", commentaire.getAuthor(), "content",
+		    commentaire.getContent(), "key", key));
+	} catch (FileAlreadyExistsException e) {
+	    LOG.error(Tools.getStackTrace(e));
+	    return false;
+	}
+
+    }
+
+    public SessionManager getSessionManager() {
+	return sessionManager;
+    }
+
+    public void setSessionManager(SessionManager sessionManager) {
+	this.sessionManager = sessionManager;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/ImageDaoImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/ImageDaoImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/ImageDaoImpl.java	(revision 9919)
@@ -0,0 +1,270 @@
+package fr.mael.jiwigo.dao.impl;
+
+import java.io.File;
+import java.io.IOException;
+import java.security.NoSuchAlgorithmException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+
+import sun.misc.BASE64Encoder;
+import fr.mael.jiwigo.dao.ImageDao;
+import fr.mael.jiwigo.om.Image;
+import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
+import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+import fr.mael.jiwigo.transverse.exception.WrongChunkSizeException;
+import fr.mael.jiwigo.transverse.session.SessionManager;
+import fr.mael.jiwigo.transverse.util.Tools;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+
+ * Dao of the images
+ * @author mael
+ *
+ */
+public class ImageDaoImpl implements ImageDao {
+
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(ImageDaoImpl.class);
+
+    /**
+     * cache to avoid downloading image for each access
+     */
+    private HashMap<Integer, List<Image>> cache;
+
+    /**
+     *
+     */
+    private Integer firstCatInCache;
+
+    private SessionManager sessionManager;
+
+    private ArrayList<File> filesToSend;
+
+    public ImageDaoImpl() {
+	cache = new HashMap<Integer, List<Image>>();
+    }
+
+    /**
+     * Lists all images
+     * @return the list of images
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Image> list(boolean refresh) throws IOException, ProxyAuthenticationException {
+	return listByCategory(null, refresh);
+    }
+
+    /**
+     * Listing of the images for a category
+     * @param categoryId the id of the category
+     * @return the list of images
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Image> listByCategory(Integer categoryId, boolean refresh) throws IOException,
+	    ProxyAuthenticationException {
+	if (refresh || cache.get(categoryId) == null) {
+	    Document doc = null;
+	    if (categoryId != null) {
+		doc = sessionManager.executeReturnDocument(MethodsEnum.LISTER_IMAGES.getLabel(), "cat_id", String
+			.valueOf(categoryId));
+	    } else {
+		doc = sessionManager.executeReturnDocument(MethodsEnum.LISTER_IMAGES.getLabel());
+	    }
+	    Element element = (Element) doc.getDocumentElement().getElementsByTagName("images").item(0);
+	    List<Image> images = getImagesFromElement(element);
+	    cache.remove(categoryId);
+	    cache.put(categoryId, images);
+	    if (firstCatInCache == null) {
+		firstCatInCache = categoryId;
+	    }
+	    return images;
+	} else {
+	    return cache.get(categoryId);
+	}
+    }
+
+    /**
+     * Creation of an image<br/>
+     * Sequence : <br/>
+     * <li>
+     * <ul>sending of the thumbnail in base64, thanks to the method addchunk.</ul>
+     * <ul>sending of the image in base64, thanks to the method addchunk</ul>
+     * <ul>using of the add method to add the image to the database<ul>
+     * </li>
+     * Finally, the response of the webservice is checked
+     *
+     * @param image the image to create
+     * @return true if the creation of the image was the successful
+     * @throws IOException
+     * @throws NoSuchAlgorithmException
+     * @throws WrongChunkSizeException
+     * @throws Exception
+     */
+    //TODO ne pas continuer si une des reponses precedentes est negative
+    public boolean create(Image image, Double chunkSize) throws FileAlreadyExistsException, IOException,
+	    ProxyAuthenticationException, NoSuchAlgorithmException, WrongChunkSizeException {
+	//thumbnail converted to base64
+	BASE64Encoder base64 = new BASE64Encoder();
+
+	String thumbnailBase64 = base64.encode(Tools.getBytesFromFile(image.getThumbnail()));
+	//sends the thumbnail and gets the result
+	Document reponseThumb = (sessionManager.executeReturnDocument("pwg.images.addChunk", "data", thumbnailBase64,
+		"type", "thumb", "position", "1", "original_sum", Tools.getMD5Checksum(image.getOriginale()
+			.getAbsolutePath())));
+
+	//begin feature:0001827
+	int chunk = chunkSize.intValue();
+	if (chunk == 0) {
+	    throw new WrongChunkSizeException("Error : the chunk size cannot be 0");
+	}
+	filesToSend = Tools.splitFile(image.getOriginale(), chunk);
+	boolean echec = false;
+	for (int i = 0; i < filesToSend.size(); i++) {
+	    File fichierAEnvoyer = filesToSend.get(i);
+	    String originaleBase64 = base64.encode(Tools.getBytesFromFile(fichierAEnvoyer));
+	    Document reponseOriginale = (sessionManager.executeReturnDocument("pwg.images.addChunk", "data",
+		    originaleBase64, "type", "file", "position", String.valueOf(i), "original_sum", Tools
+			    .getMD5Checksum(image.getOriginale().getAbsolutePath())));
+	    if (!Tools.checkOk(reponseOriginale)) {
+		echec = true;
+		break;
+	    }
+	}
+	//end
+
+	//add the image in the database and get the result of the webservice
+	Document reponseAjout = (sessionManager.executeReturnDocument("pwg.images.add", "file_sum", Tools
+		.getMD5Checksum(image.getOriginale().getAbsolutePath()), "thumbnail_sum", Tools.getMD5Checksum(image
+		.getThumbnail().getCanonicalPath()), "position", "1", "original_sum", Tools.getMD5Checksum(image
+		.getOriginale().getAbsolutePath()), "categories", String.valueOf(image.getIdCategory()), "name", image
+		.getName(), "author", sessionManager.getLogin(), "level", image.getPrivacyLevel()));
+	LOG.debug("Response add : " + Tools.documentToString(reponseAjout));
+	//	System.out.println(Main.sessionManager.executerReturnString("pwg.images.add", "file_sum", Outil
+	//		.getMD5Checksum(image.getOriginale().getAbsolutePath()), "thumbnail_sum", Outil.getMD5Checksum(image
+	//		.getThumbnail().getCanonicalPath()), "position", "1", "original_sum", Outil.getMD5Checksum(image
+	//		.getOriginale().getAbsolutePath()), "categories", String.valueOf(image.getIdCategory()), "name", image
+	//		.getName(), "author", Main.sessionManager.getLogin()));
+	//	Document reponsePrivacy = null;
+	//	if (Outil.checkOk(reponseAjout)) {
+	//	    reponsePrivacy = Main.sessionManager.executerReturnDocument(MethodsEnum.SET_PRIVACY_LEVEL.getLabel());
+	//	}
+	boolean reussite = true;
+	if (!Tools.checkOk(reponseThumb) || echec || !Tools.checkOk(reponseAjout)) {
+	    reussite = false;
+	}
+	deleteTempFiles();
+	return reussite;
+
+    }
+
+    /**
+     * Add tags to an image
+     * @param imageId id of the image
+     * @param tagId ids of the tags
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public boolean addTags(Integer imageId, String tagId) throws IOException, ProxyAuthenticationException {
+	Document doc = sessionManager.executeReturnDocument(MethodsEnum.SET_INFO.getLabel(), "image_id", String
+		.valueOf(imageId), "tag_ids", tagId);
+	try {
+	    return Tools.checkOk(doc);
+	} catch (FileAlreadyExistsException e) {
+	    LOG.error(Tools.getStackTrace(e));
+	    return false;
+	}
+
+    }
+
+    /**
+     * parse an element to find images
+     * @param element the element to parse
+     * @return the list of images
+     */
+    private List<Image> getImagesFromElement(Element element) {
+	//	List<Element> listElement = (List<Element>) element.getChildren("image");
+	NodeList listImages = element.getElementsByTagName("image");
+	ArrayList<Image> images = new ArrayList<Image>();
+	for (int i = 0; i < listImages.getLength(); i++) {
+	    Node nodeImage = listImages.item(i);
+	    if (nodeImage.getNodeType() == Node.ELEMENT_NODE) {
+		Element im = (Element) nodeImage;
+		Image myImage = new Image();
+		myImage.setThumbnailUrl(im.getAttribute("tn_url"));
+		myImage.setUrl(im.getAttribute("element_url"));
+		myImage.setWidth(Integer.valueOf(im.getAttribute("width")));
+		myImage.setHeight(Integer.valueOf(im.getAttribute("height")));
+		myImage.setFile(im.getAttribute("file"));
+		myImage.setSeen(Integer.valueOf(im.getAttribute("hit")));
+		myImage.setIdentifier(Integer.valueOf(im.getAttribute("id")));
+		myImage.setName(Tools.getStringValueDom(im, "name"));
+		Element elementCategories = (Element) im.getElementsByTagName("categories").item(0);
+		Element elementCategory = (Element) elementCategories.getElementsByTagName("category").item(0);
+		myImage.setIdCategory(Integer.valueOf(elementCategory.getAttribute("id")));
+		if (myImage.getName() == null) {
+		    myImage.setName(myImage.getFile());
+		}
+		images.add(myImage);
+	    }
+	}
+	return images;
+    }
+
+    /**
+     * Search images
+     * @param searchString the string to search
+     * @return the list of images matching the string
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Image> search(String searchString) throws IOException, ProxyAuthenticationException {
+	Document doc = sessionManager.executeReturnDocument(MethodsEnum.SEARCH.getLabel(), "query", searchString);
+	LOG.debug(Tools.documentToString(doc));
+	Element element = (Element) doc.getDocumentElement().getElementsByTagName("images").item(0);
+	return getImagesFromElement(element);
+
+    }
+
+    private void deleteTempFiles() {
+	File file = new File(System.getProperty("java.io.tmpdir") + "/originale.jpg");
+	file.delete();
+	file = new File(System.getProperty("java.io.tmpdir") + "/thumb.jpg");
+	file.delete();
+	for (File tempCut : filesToSend) {
+	    tempCut.delete();
+	}
+
+    }
+
+    public SessionManager getSessionManager() {
+	return sessionManager;
+    }
+
+    public void setSessionManager(SessionManager sessionManager) {
+	this.sessionManager = sessionManager;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/TagDaoImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/TagDaoImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/dao/impl/TagDaoImpl.java	(revision 9919)
@@ -0,0 +1,127 @@
+package fr.mael.jiwigo.dao.impl;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.Node;
+import org.w3c.dom.NodeList;
+
+import fr.mael.jiwigo.dao.TagDao;
+import fr.mael.jiwigo.om.Image;
+import fr.mael.jiwigo.om.Tag;
+import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
+import fr.mael.jiwigo.transverse.enumeration.TagEnum;
+import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+import fr.mael.jiwigo.transverse.session.SessionManager;
+import fr.mael.jiwigo.transverse.util.Tools;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+ * Dao of the categories
+ * @author mael
+ *
+ */
+public class TagDaoImpl implements TagDao {
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(ImageDaoImpl.class);
+
+    private SessionManager sessionManager;
+
+    /**
+     * lists the tags
+     * @return the list of tags
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Tag> list() throws IOException, ProxyAuthenticationException {
+	Document doc = sessionManager.executeReturnDocument(MethodsEnum.TAGS_ADMIN_LIST.getLabel());
+	//	System.out.println(Outil.documentToString(doc));
+
+	return getTagsFromDocument((Element) doc.getDocumentElement().getElementsByTagName("tags"));
+
+    }
+
+    /**
+     * COnstructs a list of tags from a document
+     * @param doc the document
+     * @return the list of tags
+     */
+    private List<Tag> getTagsFromDocument(Element element) {
+	NodeList listTags = element.getElementsByTagName("tag");
+
+	//	List<Element> listElement = (List<Element>) element.getChildren("tag");
+	ArrayList<Tag> tags = new ArrayList<Tag>();
+	for (int i = 0; i < listTags.getLength(); i++) {
+	    Node nodeTag = listTags.item(0);
+	    if (nodeTag.getNodeType() == Node.ELEMENT_NODE) {
+		Element tagElement = (Element) nodeTag;
+		Tag tag = new Tag();
+		tag.setIdentifier(Integer.valueOf(tagElement.getAttribute(TagEnum.ID.getLabel())));
+		tag.setName(tagElement.getAttribute(TagEnum.NAME.getLabel()));
+		tags.add(tag);
+	    }
+	}
+	return tags;
+
+    }
+
+    /**
+     * Creation of a tag
+     * @param tag the tag to create
+     * @return true if the tag as been successfully created
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(Tag tag) throws ProxyAuthenticationException {
+	try {
+	    return Tools.checkOk(sessionManager.executeReturnDocument(MethodsEnum.ADD_TAG.getLabel(), "name", tag
+		    .getName()));
+	} catch (IOException e) {
+	    LOG.error(Tools.getStackTrace(e));
+	} catch (FileAlreadyExistsException e) {
+	    e.printStackTrace();
+	}
+	return false;
+    }
+
+    /**
+     * Function that returns the tags for an image
+     * @param image the image
+     * @return the tags list
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException {
+	Document doc = sessionManager.executeReturnDocument(MethodsEnum.GET_INFO.getLabel(), "image_id", String
+		.valueOf(image.getIdentifier()));
+	Element elementImage = (Element) doc.getDocumentElement().getElementsByTagName("image").item(0);
+	Element elementTag = (Element) elementImage.getElementsByTagName("tags").item(0);
+	return getTagsFromDocument(elementTag);
+    }
+
+    public SessionManager getSessionManager() {
+	return sessionManager;
+    }
+
+    public void setSessionManager(SessionManager sessionManager) {
+	this.sessionManager = sessionManager;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/CategoryService.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/CategoryService.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/CategoryService.java	(revision 9919)
@@ -4,57 +4,8 @@
 import java.util.List;
 
-import fr.mael.jiwigo.dao.CategoryDao;
 import fr.mael.jiwigo.om.Category;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
-
- * @author mael
- *
- */
-public class CategoryService {
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(CategoryService.class);
-
-    /**
-     * singleton
-     */
-    private static CategoryService instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * @return the singleton
-     */
-    public static CategoryService getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new CategoryService(sessionManager);
-	}
-	return instance;
-    }
-
-    /**
-     * private constructor to use a singleton
-     */
-    private CategoryService(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-
-    }
-
+public interface CategoryService {
     /**
      * Lists all categories
@@ -64,7 +15,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Category> list(boolean recursive) throws IOException, ProxyAuthenticationException {
-	return CategoryDao.getInstance(sessionManager).list(recursive);
-    }
+    public List<Category> list(boolean recursive) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -74,21 +23,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Category> makeTree() throws IOException, ProxyAuthenticationException {
-	List<Category> list = CategoryDao.getInstance(sessionManager).list(true);
-	for (Category category : list) {
-	    for (Category category2 : list) {
-		if (category2.getIdParentCategories().size() != 1
-			&& category.getIdentifier().equals(
-				category2.getIdParentCategories().get(category2.getIdParentCategories().size() - 2))) {
-		    category.getChildCategories().add(category2);
-		    category2.getParentCategories().add(category);
-		}
-
-	    }
-	}
-
-	return list;
-
-    }
+    public List<Category> makeTree() throws IOException, ProxyAuthenticationException;
 
     /**
@@ -99,10 +32,5 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean create(String nom, Integer parent) throws ProxyAuthenticationException {
-	Category category = new Category();
-	category.setDirectParent(parent);
-	category.setName(nom);
-	return CategoryDao.getInstance(sessionManager).create(category);
-    }
+    public boolean create(String nom, Integer parent) throws ProxyAuthenticationException;
 
     /**
@@ -112,8 +40,4 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean create(String nom) throws ProxyAuthenticationException {
-	Category category = new Category();
-	category.setName(nom);
-	return CategoryDao.getInstance(sessionManager).create(category);
-    }
+    public boolean create(String nom) throws ProxyAuthenticationException;
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/CommentService.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/CommentService.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/CommentService.java	(revision 9919)
@@ -4,56 +4,8 @@
 import java.util.List;
 
-import fr.mael.jiwigo.dao.CommentDao;
 import fr.mael.jiwigo.om.Comment;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
-
- * @author mael
- *
- */
-public class CommentService {
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(CommentService.class);
-
-    /**
-     * singleton
-     */
-    private static CommentService instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * @return the singleton
-     */
-    public static CommentService getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new CommentService(sessionManager);
-	}
-	return instance;
-    }
-
-    /**
-     * private constructor, to use a singleton
-     */
-    private CommentService(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-    }
-
+public interface CommentService {
     /**
      * Lists all comments for an image
@@ -63,7 +15,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Comment> list(Integer imageId) throws IOException, ProxyAuthenticationException {
-	return CommentDao.getInstance(sessionManager).list(imageId);
-    }
+    public List<Comment> list(Integer imageId) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -77,11 +27,5 @@
      */
     public boolean create(String content, Integer imageId, String auteur) throws IOException,
-	    ProxyAuthenticationException {
-	Comment comment = new Comment();
-	comment.setContent(content);
-	comment.setImageId(imageId);
-	comment.setAuthor(auteur);
-	return CommentDao.getInstance(sessionManager).create(comment);
-    }
+	    ProxyAuthenticationException;
 
 }
